#ifndef _INDEX
#define _INDEX


#include <stdlib.h>
#include <vector>
#include <algorithm>
#include <string>
#include <iostream>
#include <db_init.h>
#include <fcntl.h>
#include <errno.h>
#include <fstream>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <set>
#include <list>
#include "interface.h"

using namespace std;

class CSpellIndex:public CInterface {

  public:
    CSpellIndex (bool hasTransp, EAlphabet );
    virtual ~ CSpellIndex ();
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    virtual bool DumpDB (const char *base_name);
    virtual bool OpenDB (const char *base_name, bool create = false);
    virtual bool CloseDB ();

    static const int pagesize = 2 * 1024;
    static const int cachesize = 0;//128 * 1024;
  protected:
    char *ABC;

    typedef StringHashSet StringSet;
    StringSet Dict;
    DB *dbp;
    DB_ENV *dbenv;
    bool opened;
};

#endif
