#include <iostream>
#include <iomanip>

#include "../Common/mytest.h"

#include "comptrie.h"
#include "testcomptrie.h"
#include "nodealloc.h"

using namespace std;

bool
TestFixedTries1()
{
    return test1(true);
}

bool
TestFixedTries2()
{
    return test2(true);
}

bool
TestFixedTries3()
{
    return test3(true);
}

bool
TestFixedTries4()
{
    return test4(true);
}

bool
TestFixedTries5()
{
    return test5(true);
}

bool
TestFixedTries6()
{
    return test6(true);
}

bool
TestFixedTries7()
{
    return test7(true);
}

bool
TestFixedTries8()
{
    return test8(true);
}

bool
TestRandom1()
{
    srand(0);
    return TestRandom(1,10, 100, 20, true);
}

bool
TestRandom2()
{
    srand(0);

    for (int i = 0; i < 5; ++i) {
        cout << "Iteration #" << i << endl;

        int len1 = 100000 * (1 + rand() % 5);
        int len2 = 100000 * (1 + rand() % 5);
    
        TEST_COND_MSG_RETURN_FALSE(TestRandom(1,8, len1, len2, true), "TestRandom failed");
    }

    return true;
}

int main(int argc, char* pArgv[]) {
    int nFail = 0, nTest = 0;

    TEST_NO_FAIL(TestFixedTries1(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries2(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries3(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries4(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries5(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries6(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries7(), nFail, nTest);
    TEST_NO_FAIL(TestFixedTries8(), nFail, nTest);
    TEST_NO_FAIL(TestRandom1(), nFail, nTest);
    TEST_NO_FAIL(TestRandom2(), nFail, nTest);

    cout << nTest << " test(s) performed, " << nFail << " test(s) failed." << endl;

    return nFail;
}
