#include <string>
#include <set>
#include <vector>
#include <iostream>
#include <sstream>
#include <stdexcept>

#include "testutil.h"

#define MAX_ATTEMPTS 100

using namespace std;

typedef vector<string>              vs;
typedef set<string>                 ss;

void GenRandString(int MinLen, int MaxLen, string &s) {
    int Len = (MaxLen > MinLen) ? MinLen + rand() % (MaxLen - MinLen): MinLen;
    s.resize(Len);

    for (int i = 0; i < Len; ++i) {
        s[i] = 'a' + rand() % ('z' - 'a');
    }
}

void GenRandStringList(int MinLen, int MaxLen, bool bUnique, size_t ListSize, vs& Result)
{
    Result.clear();
    ss                  Res;

    while (Res.size() < ListSize) {
        int i = 0;
        string  s;
        for (; i < MAX_ATTEMPTS; ++i) {
            GenRandString(MinLen, MaxLen, s);
            if (bUnique && Res.find(s) != Res.end()) { continue; }
            else break;
        }

        if (i == MAX_ATTEMPTS) {
            stringstream err;
            err << "Cannot generate a unique string after " << MAX_ATTEMPTS << " attempts";
            cerr << err.str() << endl;
            throw runtime_error(err.str());
        }

        Res.insert(s);
    }

    copy(Res.begin(), Res.end(), back_inserter(Result));
}
