#include <string.h>
#include <stdio.h>
#include "format.h"

string Format (const char *fmt, ...)
{
    unsigned int bufSize = strlen (fmt) + 1;
    char *buf;
    va_list va;
    string res;

    va_start (va, fmt);

    for (;; bufSize = bufSize * 2 + 1) {
        buf = new char[bufSize];
        if (vsnprintf (buf, bufSize, fmt, va) < (int) bufSize) {
            res = buf;
            delete[]buf;
            break;
        }
        delete[]buf;
    }
    va_end (va);
    return res;
}

#ifdef _TEST_FORMAT
const int testSize = 4;

int main ()
{
    int nFailed = 0;
    string exp[testSize] =
        { "01234567test", "66x67y68z", "", "00999.77777" };
    string res[testSize];
    res[0] = Format ("%08d%s", 1234567, "test", "");
    res[1] = Format ("%dx%dy%dz", 66, 67, 68);
    res[2] = Format ("");
    res[3] = Format ("%011.5f", 999.77777);
    for (int i = 0; i < testSize; i++) {
        if (res[i] != exp[i]) {
            printf ("Test #%d failed, expected %s but received %s\n", i,
                    exp[i].c_str (), res[i].c_str ());
            nFailed++;
        }
    }
    printf ("%d tests performed, %d failed\n", testSize, nFailed);
    return 0;
}
#endif
