#include <iostream>

#include "../Interface/hashport.h"
#include "hash.h"

using namespace std;

const unsigned long from__stl_prime_list[from__stl_num_primes] =
{
  53ul,         97ul,         193ul,       389ul,       769ul,
  1543ul,       3079ul,       6151ul,      12289ul,     24593ul,
  49157ul,      98317ul,      196613ul,    393241ul,    786433ul,
  1572869ul,    3145739ul,    6291469ul,   12582917ul,  25165843ul,
  50331653ul,   100663319ul,  201326611ul, 402653189ul, 805306457ul, 
  1610612741ul, 3221225473ul, 4294967291ul
};

bool insertHashDB(const string & str, size_t &buckNum, const CHashParams& Params, size_t* pHash, long long* pSeekVal) 
{
    // checks are ommitted here for speed
    size_t origPos = hash_func(str) % Params.hashSize;
    size_t pos = origPos;
    do {
        if (!pHash[pos]) { // free cell, zero address is not stored
            pHash[pos] = 1; // just mark it is busy
            buckNum = pos;
            return true;
        }
        pos = (pos + SKIP_CONSTANT) % Params.hashSize; // hashing with an open address, linear search
        if (pSeekVal) {
            (*pSeekVal)++;
         }
        // for a free pos
    } while (pos != origPos);
    cerr << "Hash table is full" << endl;
    return false;
}
