#include "mem_alloc.h"
#include <assert.h>

// we are freeing memory only in destructor
CFastAllocator::~CFastAllocator() 
{
    for (unsigned int i = 0; i < mAllocatedBlocks.size(); ++i) {
        delete [] mAllocatedBlocks[i];
    }
};

void * CFastAllocator::allocChunk()
{
     if (mFreeChunks.empty()) {
         char * p = new char [mBlockSize];    

         mAllocatedBlocks.push_back(p);
         for (unsigned i = 0; i < mReserveCnt; ++i, p += mChunkSize) {
#ifdef USE_LIST
             mFreeChunks.insert(mFreeChunks.end(), p);
#else
             mFreeChunks.push(p);
#endif
         }
     }

#ifdef USE_LIST
     void * p = *mFreeChunks.begin();
     mFreeChunks.erase(mFreeChunks.begin());
#else
     void * p = mFreeChunks.top();
     mFreeChunks.pop();
#endif
     assert(p);
     return p;

}

void CFastAllocator::freeChunk(void * p) {
     assert(p);
#ifdef USE_LIST
     mFreeChunks.insert(mFreeChunks.end(), (char *)p);
#else
     mFreeChunks.push((char *)p);
#endif
}
