#include "macrotest.h"
#include "int_coder.h"

using namespace std;

const char * file3 = "testDeltaMacro.tmp";

void testMacroWrite(const VI & data)
{
    unsigned int i = 0;
    int      t;

    CFileWrapper file;
    file.open(file3, O_RDWR | O_CREAT | O_TRUNC);

    DeclareOutNamedBuf(1024 * 256, outbuf); 
    StartOutput(file.getFd(), outbuf);

    for (i = 0; i < data.size(); ++i) {
        DeltaEncode(data[i], outbuf);
    }

    FinishOutput(outbuf);

    file.close();

    return;
outbufError:
    THROW_RUNTIME_ERROR("writing: " + SysError());
}

void testMacroRead(const VI & data)
{
    unsigned int i = 0;
    int      t;

    CFileWrapper file;
    file.open(file3, O_RDONLY);

    DeclareInNamedBuf(1024 * 256, inbuf);
    StartInput(file.getFd(), inbuf);

    for (;i < data.size(); ++i) {
        DeltaDecode(t, inbuf);
        if (t != data[i]) {
            cerr << "data element # " << i << " does not match, got: " << t << " expected " << data[i] << endl;
            return;
        }
    }

    return;
inbufError:
    THROW_RUNTIME_ERROR("reading: " + SysError());
inbufFinish:
    stringstream str;
    str << "EOF prematurely ended on line " << i << " of " << data.size() << endl;
    THROW_RUNTIME_ERROR(str.str());
}
