#ifndef _KDTREE_INDEX_H
#define _KDTREE_INDEX_H

#include "interface.h"
#include "kdtree.h"
#include "freqvector.h"

class CFreqKdTreeIndex:public CInterface {
  protected:
    int fd;
    bool opened;

    CFreqVectorMap   vMap;

    CFastAllocator * kdAlloc;
    CFastAllocator * vecAlloc;
    unsigned int     MaxFuzzy;
    StringList       dict;
    kdtree * kd;
    void MakeBalanced ();
    int  GetMaxFuzzy();
    void StringToVec(const char *str, unsigned int vecSize, VectorType * vec);
  public:
     CFreqKdTreeIndex(bool hasTransp, EAlphabet AlphaType);
     virtual ~ CFreqKdTreeIndex ();

    bool CreateInMemIndex(const char *inputFile,
                             int insertCount, int *dcnt, 
                             bool silent = true);
    //=========================================================================
    bool Insert (const char *str);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CloseDB ();
};


#endif
