#ifndef _CINDEX_H
#define _CINDEX_H

#include "kdtree.h"
#include "freqvector.h"

#include "alphabet.h"
#include "langcase.h"

class CIndex {
  protected:
    bool             mHasTransp;
    EAlphabet        mAlphaType;
    CFreqVectorMap   vMap;

    CFastAllocator * kdAlloc;
    CFastAllocator * vecAlloc;
    unsigned int     MaxFuzzy;
    kdtree * kd;
    void MakeBalanced ();
    void Insert(const string &str);
    int  GetMaxFuzzy();
    void StringToVec(const string &str, unsigned int vecSize, VectorType * vec);
  public:
    CIndex(bool hasTransp, EAlphabet AlphaType);
    virtual ~CIndex();

    bool CreateIndex(const char *inputFile);
    void Traverse(const string &str, int d, vd &stat);
};


#endif
