#include "index.h"

int main (int argc, char *argv[])
{
    if (argc != 4) {
        cerr << "Usage : " << argv[0] << " <dict file> <test file> <hasTransp?>\n";
        return -1;
    }
    bool hasTransp = atol(argv[3]);
    
    string              s;
    GetEnv(ENV_ABC, s);
    EAlphabet           AlphaType = GetAlphabetType(s);

    if (AlphaType == eUnknown) {
        cerr << "Unknown alphabet: '" << s << "' check env var " << ENV_ABC << endl;
        return 0;
    }
    CIndex indx(hasTransp, AlphaType);

    if (!indx.CreateIndex(argv[1])) {
        cerr << "Cannot create index from '" << argv[1] << "'\n";
        return -1;
    }

    ifstream ftest(argv[2]);

    if (!ftest) {
        Perror("Cannot open test file");
        return -1;
    }

    string str;
    vd     stat[2];
    int    cnt = 0;

    int    N = 0;
    int    errMax = 2;
    while (ftest >> str) {

        for (int d = 1; d <= errMax; ++d) {
            vd stat2;
            indx.Traverse(str, d, stat2);

            if (N) {
                assert(N == stat2.size());
            } else {
                N = stat2.size();
                for (int k = 1; k <= errMax; ++k) {
                    stat[k - 1].resize(N);
                }
            }

            for (int i = 0; i < N; ++i) {
                stat[d - 1][i] += stat2[i];
            }
        }

        ++cnt;
    }

    for (int d = 1; d <= 2; ++d) {
        cout << " D = " << d << endl;
        for (int i = 0; i < N; ++i) {
            cout << i << ": " << stat[d - 1][i] / cnt << " ";
        }
        cout << endl;
    }

    return 0;
};
