#ifndef _INDEX_H
#define _INDEX_H
#include "storeobj.h"
#include "interface.h"
#include <fcntl.h>

class CFreqTrieIndex: public CInterface {
  protected:
    CFreqVectorMap vMap;
    CFreqVectorList ind;
    bool opened;
    int fd;
  public:
     CFreqTrieIndex (bool hasTransp, EAlphabet AlphaType);
    ~CFreqTrieIndex ();

    //=========================================================================
    bool Insert (const char *str);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CloseDB ();
    void PrintAddStat(SearchType type, int testNum, int kerr, ostream & ostr);
#ifdef _DEBUG
    void Print ();
#endif
};

#endif
