#ifndef _INDEX_H
#define _INDEX_H
#include "storeobj.h"
#include "interface.h"
#include <fcntl.h>

class CFreqTrieIndexOptimized:public CInterface {
  protected:
    CFreqVectorMap  vMap;
    CFreqVectorList ind;
    bool opened;
    int fd;
  public:
     CFreqTrieIndexOptimized (bool hasTransp, EAlphabet AlphaType);
    ~CFreqTrieIndexOptimized ();

    bool CreateInMemIndex(const char *inputFile,
                             int insertCount, int *dcnt, 
                             bool silent = true);
    //=========================================================================
    bool Insert (const char *str);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CloseDB ();
#ifdef _DEBUG
    void Print ();
#endif
};

#endif
