#ifndef CGRAM_H
#define CGRAM_H

#include <sys/types.h>

/* VectorType must be unsigned!!! */
typedef u_int8_t VectorType;

const VectorType VectorTypeMax = VectorType (2LL << (8 * sizeof (VectorType))) - 1;

void StringToNgramVec (const char *str, unsigned int ngramSize,
                       unsigned int vecSize, VectorType * vec);
void PrintNgramVec (unsigned int vecSize, const VectorType * vec);
/* 
   The following function converts maximum allowed Levenstein distance into 
   a maximum allowd ngram difference taking that string to ngram vector
   conversion is done with StringToNgramVec
*/
unsigned int NgramMaxErrNum (unsigned int kerr, unsigned int ngramSize,
                             unsigned int vecSize, bool hasTransp);


#endif
