#ifndef _LEN1INDEX_BDB_H
#define _LEN1INDEX_BDB_H

#include "len1index.h"
#include "db_init.h"

class CLen1IndexBDB : public CLen1Index 
{
  protected:
    DB     * dbp;
    DB_ENV * dbenv;

    bool DumpDBCompress(const char *index_name, mOffset &);
    bool ReadListDBCompress(const char *str, int StrLen, int minpos, int maxpos,
                     OffsetList * ptr);
    bool ReadListDBNoCompress(const char *str, int StrLen, int minpos, int maxpos,
                     OffsetList * ptr);
    bool DumpDBNoCompress(const char *index_name, mOffset &);

  public:
    CLen1IndexBDB(int NgramLen, bool hasTransp, bool hasCompress) 
            : CLen1Index(NgramLen, hasTransp, hasCompress, false), dbenv(NULL) {}

    bool OpenDB (const char *name, bool create = false);
    bool CloseDB ();
    bool DumpDB (const char *index_name, mOffset &);
    bool ReadListDB (const char *str, int StrLen, int minpos, int maxpos,
                     OffsetList * ptr);
    void ResetCounters();
    void PrintAddStat(int testNum, int kerr, ostream &);
#ifdef _DEBUG
    void Print ();
#endif
    DECLARE_STATIC_COUNTER(load_list);
} ;

#endif
