#include "ngram.h"

ngram::operator        u_int64_t ()
{
    return val;
}

void ngram::pack (const char *str, int slen, int pos)
{
    val = 0;
    for (int i = 0; i < slen; i++) {
        val = (val << 8) + ((unsigned char) str[i]);
    }
    val <<= StrShift;
    val &= StrMask;
    if (pos < 0)
        pos = 0;
    if (pos > MaxPos)
        pos = MaxPos;
    val |= ((pos << PosShift) & PosMask);
}

int ngram::PosFromStr (const char *str, int ngramlen)
{
    return ((unsigned char) str[ngramlen]);
}

void ngram::toStr (char *str, int ngramlen)
{
    u_int64_t val1 = ((val & StrMask) >> StrShift);
    for (int i = 0; i < ngramlen; i++) {
        str[ngramlen - i - 1] = val1 % 256;
        val1 >>= 8;
    }
    str[ngramlen] = (unsigned char) ((val << PosShift) & PosMask);
    str[ngramlen + 1] = 0;
}
