#ifndef _NGRAM
#define _NGRAM
#include <map>
#include <sys/types.h>
#include <ctype.h>

// This file contains function for packing/unpacking ngram information
// into a 64-bit unsigned integer


struct ngram {
  protected:
    u_int64_t val;
  public:
    static const u_int64_t StrMask = 0xffffffffffffff00LL;
    static const u_int64_t StrShift = 8;
    static const u_int64_t PosMask = 0x00000000000000ffL;
    static const u_int64_t PosShift = 0;
    static const int MaxPos = 255;
    ngram (u_int64_t _val = 0):val (_val) {} 
    operator  u_int64_t ();
    void      pack (const char *str, int slen, int pos);
    void      toStr (char *str, int ngramlen);
    static    int PosFromStr (const char *str, int ngramlen);

    int Pos () {
        return (val & PosMask) >> PosShift;
    }
};

#endif
