#ifndef _INDEX_H
#define _INDEX_H
#include "interface.h"
#include <vector>

struct Tripple {
    unsigned int   m_wordId : 14;
    unsigned char  m_pos1;
    unsigned int   m_isTransp1 : 1;
    unsigned char  m_pos2;
    unsigned int   m_isTransp2 : 1;
    Tripple(u_int16_t wordId, 
            unsigned char pos1 = 255, bool isTransp1 = 0, 
            unsigned char pos2 = 255, bool isTransp2 = 0) : 
            m_wordId(wordId), m_pos1(pos1), m_isTransp1(isTransp1), m_pos2(pos2) {}
};

typedef vector<Tripple> TrippleList;
typedef hash_map<string, TrippleList> TrippleListMap;

class CHashFilterIndex : public CInterface {
  protected:
    vector<string>    m_dict;
    TrippleListMap    m_hash;
  public:
    CHashFilterIndex (bool hasTransp, EAlphabet AlphaType) : CInterface(hasTransp, AlphaType) {}
    virtual ~CHashFilterIndex() {}

    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    // Dummy DB functions
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true) {
        return true;
    }
    virtual bool DumpDB (const char *file_name) {return true;}
    virtual bool OpenDB (const char *file_name, bool create = false){return true;}
    virtual bool CloseDB (){ return true;}
    //=========================================================================
};

#endif
