#ifndef HASH_PORT_H
#define HASH_PORT_H

#include <string.h>

#ifdef _STLPORT_VERSION
#include <hash_map>
#include <hash_set>
inline size_t hash_func(const std::string & s) { return std::__stl_hash_string(s.c_str()); }
inline size_t hash_func(const char *p) { return std::__stl_hash_string(p); }
#else
#if __GNUC__ < 3 
#include <hash_map>
#include <hash_set>
template <>
struct hash<std::string>
{
    size_t operator()(const std::string & s) const { return __stl_hash_string(s.c_str()); }
};
inline size_t hash_func(const std::string & s) { return __stl_hash_string(s.c_str()); }
inline size_t hash_func(const char *p) { return __stl_hash_string(p); }
typedef std::hash_set<std::string> StringHashSet;
#else
#include <ext/hash_map>
#include <ext/hash_set>
namespace __gnu_cxx {
    template <>
    struct hash<std::string>
    {
        size_t operator()(const std::string & s) const { return __stl_hash_string(s.c_str()); }
    };
};

namespace std {
    using __gnu_cxx::hash_map;
    using __gnu_cxx::hash_set;
    using __gnu_cxx::hash;

    inline size_t hash_func(const std::string & s) { return __gnu_cxx::__stl_hash_string(s.c_str()); }
    inline size_t hash_func(const char *p) { return __gnu_cxx::__stl_hash_string(p); }
};
#endif
#endif

namespace std {
    struct MyHash {
        size_t operator()(const char *p) const { return hash_func(p); }
    };
    struct Equal {
        size_t operator()(const char *p1, const char *p2) const {return strcmp(p1, p2) == 0;}
    };
}

typedef std::hash_set<std::string> StringHashSet;

#endif
