#ifndef _INDEX_H
#define _INDEX_H
#include "fqnode.h"
#include "interface.h"

class CMtreeIndex:public CInterface {
  protected:
    CFQnode node;
  public:
    CMtreeIndex (bool hasTransp, EAlphabet AlphaType);
    ~CMtreeIndex ();
    bool opened;
    int fd;

    //=========================================================================
    bool Insert (const char *str);
    bool InsertList (const StringList & lst);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CreateInMemIndex (const char *inputFile,
                             int insertCount,
                             int *dcnt, bool silent = true);
    bool CloseDB ();
    void Print ();
};

#endif
