#ifndef _INDEX
#define _INDEX


#include "ngram.h"
#include "len1index.h"
#include "myagrep.h"
#include "interface.h"
#include "utils.h"
#include "../SeqAgrep/index.h"

class CNgramIndex1:public CInterface {
  public:
    static const int NgramLen = 3;
    //static const int SeqIndexBound = 3;
    static string seqIndexName (const char *name) {
        return string (name) + ".seq";
    };
  protected:
    CLen1Index     *db;
    CAgrepIndex    seqIndex;
    PtrListVector  dict;         // The list of all strings
    bool           opened;
    int            fd;
    char           *mapDict;
    string         baseName;
    string         grmName;
    int            mapSize;
  public:
    CNgramIndex1 (bool hasTransp, EAlphabet AlphaType);
    virtual ~ CNgramIndex1 ();
    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *nComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *nComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool OpenDB (const char *base_name, bool create = false);
    virtual bool CloseDB ();
    virtual bool DumpDB (const char *base_name);
    void DisplayStat () {
		CLen1Index::DisplayStat ();
    }
    void ResetCounters();
    void PrintAddStat(SearchType type, int testNum, int kerr, ostream & ostr);
    DECLARE_STATIC_COUNTER(aseek)
#ifdef _DEBUG
    void Print ();
#endif
}

;

extern void *ptr2;

#endif
