#include "gramflt.h"
#include "../Common/utils.h"

HMap hmap;
bool first = true;

unsigned int GetMaxDigit()
{
   static struct MaxDigit {
      int MaxDigitVal;
      MaxDigit() : MaxDigitVal(VECTOR_LENGTH) {
          GetEnv("VECTOR_LENGTH", MaxDigitVal);
      }
   } maxDigitObj;
   return maxDigitObj.MaxDigitVal;
}

const HMap & getStandHmap() 
{
    if (first) {
        first = true;
        for (uchar c = 'a'; c <= 'z'; ++c) {
            int val = (c - 'a') % GetMaxDigit();
            hmap.setValue(c, val);
            hmap.setValue(toupper(c), val);
        }
    }
    return hmap;
}

std::ostream & operator <<(std::ostream & out, CFullNgramInfo & gram)
{
    out << "wordId = " << gram.mWordId << " pos = " << gram.mPos << " wordLen = " << gram.mWordLen << " sign = 0x" << std::setfill('0') << std::setw(4) << std::hex << gram.mSign.getVal() ;
    return out << std::dec;
}
