#include "gramflt.h"

#include <vector>
#include <map>
#include <string>

#include "search.h"
#include "interface.h"


class CNgramFiltIndex {
typedef std::multimap<std::string, CFullNgramInfo> GramInvList;

    GramInvList                          mIndx;
    std::vector<std::string>             mWordList; 
    std::map<std::string, unsigned int>  mWordDict;
    const HMap &                         mHmap;

    unsigned int                         mGramSize;
    unsigned int                         mMaxIntersectCnt;
    bool                                 mHasTransp;

    public:
    CNgramFiltIndex(unsigned int gramSize, unsigned int maxIntersectCnt, const HMap & hmap, bool hasTransp) 
              : mGramSize(gramSize), mMaxIntersectCnt(maxIntersectCnt), mHmap(hmap), mHasTransp(hasTransp) {
              }
    void insertWord(const std::string & str);
    void search(const std::string & str, unsigned int kerr, StringList & res, unsigned int & cntCheck, unsigned int condFlags = 0);
    void printAll();
    unsigned int size() { 
        return mWordList.size();
    }

};
