#ifndef _KDTREE_INDEX_H
#define _KDTREE_INDEX_H

#include "interface.h"
#include "kdtree.h"

class CKdtreeIndex:public CInterface {
  protected:
    int fd;
    bool opened;

    CFastAllocator * kdAlloc;
    CFastAllocator * vecAlloc;
    int              MaxFuzzy;
    int              GramSize;
    StringList       dict;
    kdtree * kd;
    void MakeBalanced ();
  public:
     CKdtreeIndex ( bool hasTransp, EAlphabet AlphaType,
                    int GramSize = _NGRAM_SIZE);
     virtual ~ CKdtreeIndex ();

    bool CreateInMemIndex(const char *inputFile, 
                             int insertCount, int *dcnt, 
                             bool silent = true);
    //=========================================================================
    bool Insert (const char *str);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CloseDB ();
};


#endif
