#ifndef _INDEX_AGREP_H
#define _INDEX_AGREP_H
#include "interface.h"
#include "utils.h"

class CAgrepIndex : public CInterface {
    static const int bufsize = 64 * 1024;
    static const int MaxLen = 2048;
  protected:
    string   wordChunk;
    string   Name;
    int      recNum;
    int      cntFnd;
    void     ClearMem ();
    bool     opened;
    int      fd;
    const    static char termChar;
  public:
     CAgrepIndex (bool hasTransp, EAlphabet AlphaType);
     virtual ~ CAgrepIndex ();

    //=========================================================================
    virtual bool Insert (const char *str);
    virtual bool Search (const char *str, int kerr, int *numComp,
                         StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool SearchInDB (const char *str, int kerr, int *numComp,
                             StringList * resList, bool silent = true);
    //=========================================================================
    virtual bool DumpDB (const char *file_name);
    virtual bool OpenDB (const char *file_name, bool create = false);
    virtual bool CloseDB ();
};

#endif
