#ifndef _FBLOCK
#define _FBLOCK

#include "search.h"
#include "sign.h"
const int8 BMark = 0xff;

class FBlock {
  private: 
  protected:
      struct FBlockHeader {
        int8 CheckMark;
        int32 NextAddr;
        int32 free_pos;
        FBlockHeader ():CheckMark (BMark), NextAddr (0),
            free_pos (sizeof (FBlockHeader)) {
        };
    };
    void huge *mem;
    char huge *rptr;
    int32 BlockAddr;
    bool alloc_mem;
    void InitMem ();          // Memory initializer
  public:
    void Clear ();
    FBlock ();
    FBlock (const FBlock & b);
    
    /* ! */ FBlock (const char *ptr, const int32 b_addr = 0); // This constructor does not acutally allocate a memory
    FBlock & operator= (const FBlock & b);
    ~FBlock ();
    int32 FreeSpace () {
        return (BlockSize - ((FBlockHeader huge *) mem)->free_pos);
    }
    bool Write (int fd) {
        return Write (fd, BlockAddr);
    }
    bool Write (int fd, int32 addr);
    bool Read (int fd, int32 addr);
    bool Read (int fd) {
        return Read (BlockAddr);
    }
    bool AppendRecord (const char huge *, const Sign huge *);
    bool CanAppend (int str_len) {
        return FreeSpace () >= str_len + 1 + sizeof (int16);
    }
    int32 GetNextBlock () {
        return ((FBlockHeader huge *) mem)->NextAddr;
    }
    void SetNextBlock (int32 addr) {
        ((FBlockHeader huge *) mem)->NextAddr = addr;
    } 
    char huge *ToFirst (Sign huge * s = NULL);
    char huge *ToNext (Sign huge * s = NULL);
    char huge *ToCurr () {
        return rptr + sizeof (int16);
    };
};

#endif
