#ifndef _FDISK_INDEX
#define _FDISK_INDEX

#include "search.h"
#include "block.h"
#include "sign.h"
#include "calchash.h"
#include "interface.h"

class FIndex {
    struct block_info {
        int32 block_addr;       /* The address of the block list        */
        int16 block_count;      /* The total number of blocks in the list   */
    };
  protected:int MaxDigit;
    int32 p_count;
    HMap hsign;
    block_info *header;         // The array of block_info records
    bool opened;                // The flag indicating whether index is opened and 
    bool mHasTransp;
    // header information is read into main memory
    void Error(const char *str) {
        Perror(str);
    } int fd;                   // file descriptor of the index file
    void gen_seq();
    void init_mem();
    void free_mem();
  public:
    FIndex(bool hasTransp);
    ~FIndex();
    bool Close();
    bool Open(const char *name);
    bool Defragment(const char *name, const char *tmpname);
    bool Create(const char *name, HMap & h, int MaxDigit);
    bool FastCreate(const char *dfile, const char *dbname, HMap & h,
                    int MaxDigit, bool silent = false);
    bool Insert(const char *str);
    bool Search(const char *str, unsigned int errn, int *numComp,
                StringList * resList, bool silent = false, int32 * cnt =
                NULL);
    bool SearchSubstr(const char *str, unsigned int errn, bool silent =
                      false, int32 huge * cnt = NULL);
    bool SearchBestMatch(const char *str, bool silent =
                         false, int32 * cnt = NULL);
    bool PrintStat();
    friend int comp(const void *, const void *);
};

int comp(const void *, const void *);

inline int32 twop(int32 deg)
{
    return (1L << deg);
};

inline int32 twop(int16 deg)
{
    return (1L << deg);
};

#endif                          /*  */
