#ifndef HMAP_H
#define HMAP_H


#include <algorithm>
#include <vector>
#include <cstring>

// Mapping array
typedef unsigned char uchar;

class HMap {
    const static int arr_size = 256;
    char *arr;
    void alloc_mem () {
        arr = new char[arr_size];
    } 
    void free_mem () {
        delete arr;
        arr = NULL;
    }
    void copy_mem (char *buf) {
        memmove (arr, buf, arr_size);
    }
public:
    void clear_mem () {
        memset (arr, 0, arr_size);
    }
    HMap () {
        alloc_mem ();
        clear_mem ();
    }
    HMap (const HMap & h) {
        alloc_mem ();
        copy_mem (h.arr);
    }
    ~HMap () {
        free_mem ();
    }
    const HMap & operator= (const HMap & h) {
        if (this != &h)
            copy_mem (h.arr);
        return *this;
    }
    bool write (int fd) {
        return::write (fd, arr, arr_size) == arr_size;
    }
    bool read (int fd) {
        return::read (fd, arr, arr_size) == arr_size;
    }
    const char &operator[] (int i) const {
        if (i < 0 || i > 255)
            throw "Invalid index (HMap)";
        return arr[i];
    } 
    void setValue (int i, char value) const {
        if (i < 0 || i > 255)
            throw "Invalid index (HMap)";
        arr[i] = value;
    }
};


#endif
