#ifndef _INDEX_H
#define _INDEX_H
#include <fstream>
#include <string>
using namespace std;
#include "interface.h"
#include "diskindex.h"
#include "hashindex.h"
#include "calchash.h"


class CSignHashIndex:public CInterface {
  protected:
    HMap hsign;
    int MaxDigit;
    int GetMaxDigit();
    string mInputFile;

    CHashIndex ind;
    FIndex dind;
  public:
     CSignHashIndex (bool hasTransp, EAlphabet AlphaType);
    ~CSignHashIndex ();
    bool opened;
    int fd;

    bool CreateInMemIndex (const char *inputFile, 
                             int insertCount, int *dcnt, bool silent = true);
    //=========================================================================
    bool Insert (const char *str);
    bool InsertList (const StringList & lst);
    bool Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = true);
    //=========================================================================
    bool SearchInDB (const char *str, int kerr, int *numComp,
                     StringList * resList, bool silent = true);
    //=========================================================================
    bool DumpDB (const char *file_name);
    bool OpenDB (const char *file_name, bool create = false);
    bool CloseDB ();

    void Print () {
        cout << "Stub!" << endl;
    }
};

#endif
