#ifndef _HASHINDEX_H
#define _HASHINDEX_H
#include "search.h"
#include "sign.h"
#include "rstat.h"
#include "afuzzy.h"
#include "myagrep.h"
#include "interface.h"


typedef vector <char *> StrList;

class CHashIndex {
    // The array of buckets with strings
#ifdef USE_CHUNK
    vector<int>   HashListCnt;
    string        *HashList;
#else
    StrList       *HashList;
#endif
    // The size of the signature
    int MaxDigit;
    const HMap &  hsign;
    bool          mHasTransp;
  public:
     CHashIndex (int MaxDigit, const HMap & h, bool hasTransp);
     virtual ~ CHashIndex ();
    void Insert (const char *str);
    void Search (const char *str, int kerr, int *numComp,
                 StringList * resList, bool silent = false);
    const static char termChar;
};

#endif
