
#ifndef AFUZZY_H
#define AFUZZY_H

/*
  Leonid Boitsov
 */

#include <string.h>

#include "trie.h"

typedef u_int32_t Uint;

class context {
    friend class afuzzycontext;
    Uint *R;
    Uint *RP;
    int k;
    int startpos;
    int cnt;
  public:
     context ();
    ~context ();
     context (const context & c);
    const context & operator= (const context & c);
    void init (int);
};

class afuzzycontext {
    Uint *R1;
    Uint *RP;
    Uint *S;
    Uint *RI;
    int Map[256];
    int k;
    int m;
    Uint mask_ok;
    Uint filter_ok;
    Uint filter_shift;
    int r_size;
  public:
     afuzzycontext ();
    void init (const std::string & p, int k, context * cntx);
    bool checkRTR (const std::string & t, context *, bool final = false);
#if 0
    bool checkBEG (const string & t, context *, bool *);
#endif
    ~afuzzycontext ();
    static int MaxPatSize () {
        return sizeof (Uint) * 8;
}};


#endif
