#include <iostream>
#include <algorithm>
#include <string>
#include <iomanip>

#include <edistCut.h>

#include <string.h>

#define PP_COL(c) (((c) + 1) % 3)
#define P_COL(c) (((c) + 2) % 3)

//#define PRINT_DP 1

int checkDistLeven(bool hasTransp, const std::string & s1, const std::string & s2, int k)
{
    if (!k) {
        return int(strcmp(s1.c_str(), s2.c_str()) != 0);
    }
    const std::string * aStr[2] = {&s1, &s2};
    int   MAXE = k + 1;
    int   res = MAXE;
    int   i, j;

    if (s1.size() > s2.size()) {
        std::swap(aStr[0], aStr[1]);
    }
#ifdef PRINT_DP
    unsigned int   M0 = aStr[0]->size();
    unsigned int   M1 = aStr[1]->size();
    unsigned int   prDp[M1][M0];

    for (j = 0; j < M1; ++j)
    for (i = 0; i < M0; ++i)
        prDp[j][i] = MAXE;
#endif
    int            sz = 2 * k + 1;
    unsigned int   dp[3][sz];
    unsigned int   minVal[3];
    int            curCol = 0;

    int DeltaS = aStr[1]->size() - aStr[0]->size();
    if (DeltaS > k) {
        goto exit;
    }
    if (!aStr[1]->size()) {
        res = 0;
        goto exit;
    }

    minVal[0] = 0;

    for (i = 0; i <= k; ++i)
       dp[0][i + k] = i;

    curCol = 1;
    for (i = 0; i < aStr[0]->size(); ++i, curCol = (curCol + 1) % 3) {

        minVal[curCol] = MAXE;
        // here aStr[1]->size() != 0
        int jmin1 = i - k, 
            jmax1 = i + k;
        int jmin = std::max(jmin1, (int)0), 
            jmax = std::min(jmax1, (int)aStr[1]->size() - 1);
        int indx = jmin - jmin1;
        for (j = jmin; j <= jmax; ++j, ++indx) {
           unsigned int val = MAXE;
           // 1. subst
           val = std::min(val, dp[P_COL(curCol)][indx] + int((*aStr[0])[i] != (*aStr[1])[j]));
           
           // 2. insert
           if (j > jmin) {
               val = std::min(val, dp[curCol][indx - 1] + 1);
           }
           // 3. delete
           if (indx + 1 < sz) {
               val = std::min(val, dp[P_COL(curCol)][indx + 1] + 1);
           }
           // 4. transp
           if (hasTransp && i && j  && (*aStr[0])[i] == (*aStr[1])[j - 1] && (*aStr[0])[i - 1] == (*aStr[1])[j]) {
               val = std::min(val, dp[PP_COL(curCol)][indx] + 1);
           }
           dp[curCol][indx] = val;
#ifdef PRINT_DP
           prDp[j][i] = val;
#endif
           minVal[curCol] = std::min(val, minVal[curCol]);
        }
        if (i > 1) { // cutoff
           if (minVal[P_COL(curCol)] >= MAXE && 
               (!hasTransp || minVal[PP_COL(curCol)] >= MAXE)) {
               goto exit;
           }
        }
    }

    res = dp[P_COL(curCol)][k + DeltaS];
exit:
#ifdef PRINT_DP
    for (j = 0; j < M1; ++j)
    for (i = 0; i < M0; ++i) {
        std::cout << std::setw(2) << prDp[j][i] << " ";

        if (i == M0 - 1) 
            std::cout << std::endl;
    }
#endif
    return res;
};

