#!/bin/bash
ConfFile=$1
Method=$2

function Usage {
   echo "$0 <config file> <method name>"
}

if [ -z "$ConfFile" ] ; then
    echo "Missing config file"
    Usage
    exit 2
fi

if [ ! -f "$ConfFile" ] ; then
    echo "'$ConfFile' is not found"
    Usage
    exit 2
fi


if [ -z "$Method" ] ; then
    echo "Missing method name"
    Usage
    exit 2
fi

if [ ! -d "$Method" ] ; then
    echo "Method '$Method' is not found"
    Usage
    exit 2
fi

# Remove traling slashes
Method=`echo $Method|sed -r 's|/+$||'`

i=0
VarName=""
VarValue=""
echo "Reading config from '$ConfFile'"
for tmp in `perl -e 'open(FN, "grep -E \"^'$Method'[ \t]\" \"'$ConfFile'\" |") or die("Cannot grep"); while(<FN>){chomp;@a=split(/\s+/);print "$a[1] $a[2] ";}'` ; do 
    i=$(($i+1))
    if [ "$i" = "2" ] ; then
        if [ -z "$VarName" ] ; then
            echo "Empty variable name in config"
            exit 3
        fi
        VarValue=$tmp
        export "$VarName"="$VarValue"
        echo "Set \"$VarName\"=\"$VarValue\""
        i=0;
        VarName=""
        VarValue=""
    else
        VarName=$tmp
    fi
done
