#!/bin/bash

TestVocDir=$1

if [ "$1" = "--help" -o "$1" = "-h" -o -z "$1" ] ; then
   echo "Usage (alphabet list and dataset directory are mandatory):"
   echo "$0 <dataset directory> <alphabet list>  <dict list> <method list> <q-gram size list> <transp list>"
fi

if [ -z "$TestVocDir" ] ; then
    echo "You must specify TestVocDir as the first argument!"
    exit 1
fi

if [ ! -d "$TestVocDir" ] ; then
    echo "$TextVocDir is not a directory!"
    exit 1
fi

LangList=$2

if [ -z "$LangList" ] ; then
    echo "You must specify an alphabet as the second argument!"
    exit 1
fi

DictList=$3

if [ -z "$DictList" ] ; then
    DictList=32
fi

MethList=$4

if [ -z "$MethList" ] ; then
    MethList="NgramMultCompress"
fi

QGramSizeList=$5

if [ -z "$QGramSizeList" ] ; then
    QGramSizeList="2 3 4 5"
fi

TranspList=$6

if [ -z "$TranspList" ] ; then
    TranspList=1
fi

export SKIP_DISK=1


echo "TestVocDir: $TestVocDir"
echo "Lang:       $lang"
echo "DictList:   $DictList"
echo "MethList:   $MethList"
echo "TranspList: $TranspList"

#for i in 1 2 ; do
for i in 1 ; do

for lang in $LangList ; do
    for n in $QGramSizeList ; do
        echo "$i $lang $n"
        export NGRAM_LEN=$n
        RES_FILE_BASE="results_ngram$n"
        RES_FILE=$RES_FILE_BASE.$lang
        ./testSPEED.sh "$TestVocDir" "$lang" 1000 "$MethList" "$DictList" "$TranspList" "$RES_FILE_BASE"
        mv $RES_FILE $RES_FILE.$i
        done
    done
done
