#!/bin/bash
# To run disk tests, do the following:
# 1) Comment out the line below and two lines that unset DISK_DIR and/or FLASH_DIR
# 2) Uncomment the line that contains ./gen_purge_file
export SKIP_DISK=1
. common_var.sh

unset DISK_DIR
unset FLASH_DIR

#echo $DISK_DIR
#echo $PURGE_CACHE
#./gen_purge_file || exit 1


# Here we select only best methods (AlternGenMorFraenkel & AlternGenIndexExpansion are tested using testSPEED_MF.sh)

. mainlist.sh

METHLIST=$methlist ./check_debug || exit

. common_param.sh

export SKIP_FUNC_TEST=1
echo "Testfile: N = $N"
for dir in $methlist ; do
    # Remove trailing /
    dir=`echo $dir|sed 's|/*$||'`
    dictList=""
    for M in $dictListSize ; do
        TestFileBase=../${TestVocDir}/test${N}_${M}
        TestFileBase3=../${TestVocDir}/test100_${M}
        DictFile=../${TestVocDir}/dict${M}_$dict

        dictListTmp="${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict ${TestFileBase}_3_$dict $DictFile"
        # k = 3 and neighborhood (alternative) generation algos : use fewer patterns 
        # Because, in this case, these method maybe 10-times slower than sequential searching.
        #if [ "$ABC" != "dna" ] ; then
            if [ "$dir" = "AlternGenLinHash" -o "$dir" = "AlternGenChainHash" -o "$dir" = "AlternGenIndexExpansion2" -o "$dir" = "AlternGenMorFrank" -o "$dir" = "AlternGenIndexExpansion" -o "$dir" = "AlternGenSuperCond" ] ; then
                dictListTmp="${TestFileBase}_0_$dict ${TestFileBase}_1_$dict ${TestFileBase}_2_$dict ${TestFileBase3}_3_$dict $DictFile"
            fi
        #fi
        dictList="$dictList $dictListTmp"
    done
    if [ ! -z "$Config" ] ; then
        . ./read_conf.sh "$Config" "$dir"
    fi
  . ./run_test.sh "$dir" "$transpList" || exit 1
done
exit 0
