#!/bin/bash
if [ -z "$1" ] ; then
    echo "TestVocDir is empty!"
fi
if [ -z "$2" ] ; then
    echo "language is empty!"
fi
if [ -z "$3" ] ; then
    echo "DictList is empty!"
fi
if [ -z "$4" ] ; then
    echo "TranspList is empty!"
fi

if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] ; then
    echo "Usage: $0 <TestVocDir> <language> <DictList> <TranspList> <ResFileBase> <ConfFile>"
    exit 1
fi

TestVocDir=$1
Lang=$2
DictList=$3
TranspList=$4
RES_FILE_BASE=$5
ConfFile=$6

function first { echo $1 | awk -F. '{print $1}' ; }
function second { echo $1 | awk -F. '{print $2}' ; }

# No transpositions here
for d in $DictList ;  do
    i=`first $d`
    if [ $i -lt 5 ] ; then
        ./testSEL.sh "$TestVocDir" "$Lang" AlternGenIndexExpansion2 "$d" "$TranspList" $RES_FILE_BASE $ConfFile
    fi
done

for d in $DictList ;  do
    i=`first $d`
    if [ $i -lt 5 ] ; then
        ./testSEL.sh "$TestVocDir" "$Lang" AlternGenMorFrank "$d" "$TranspList" $RES_FILE_BASE $ConfFile
    fi
done

for d in $DictList ;  do
    i=`first $d`
    if [ $i -lt 17 ] ; then
        ./testSEL.sh "$TestVocDir" "$Lang" AlternGenIndexExpansion  "$d" "$TranspList" $RES_FILE_BASE $ConfFile
    fi
done

for d in $DictList ;  do
    i=`first $d`
    if [ $i -lt 17 ] ; then
        ./testSEL.sh "$TestVocDir" "$Lang" Cole_et_al  "$d" "$TranspList" $RES_FILE_BASE $ConfFile
    fi
done

if [ $Lang = "dna" ] ; then
    for d in $DictList ;  do
        i=`first $d`
        l=`second $d`
        if [ $l = "11" -o $i -lt 5 ] ; then
            ./testSEL.sh "$TestVocDir" "$Lang" AlternGenSuperCond  "$d" "$TranspList" $RES_FILE_BASE $ConfFile
        fi
    done
fi

exit 0
